From 46477d9d20f2fb7b0281746191e2628ff9665548 Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Feb 09 2017 15:58:10 +0000
Subject: [PATCH 726/1001] Convert the pagureissues widget


---

diff --git a/hubs/widgets/pagureissues/__init__.py b/hubs/widgets/pagureissues/__init__.py
new file mode 100644
index 0000000..2be36a8
--- /dev/null
+++ b/hubs/widgets/pagureissues/__init__.py
@@ -0,0 +1,91 @@
+from __future__ import unicode_literals
+
+import requests
+
+from hubs import validators
+from hubs.widgets.base import Widget, WidgetView
+from hubs.widgets.caching import CachedFunction
+from hubs.widgets.chrome import panel
+
+pagure_url = "https://pagure.io/api/0"
+
+
+class PagureIssues(Widget):
+
+    name = "pagureissues"
+    position = "right"
+    arguments = [
+        dict(
+            name="repo",
+            label="Repository",
+            default=None,
+            validator=validators.pagure_repo,
+            help="Pagure repo name",
+        )]
+
+
+class BaseView(WidgetView):
+
+    name = "root"
+    url_rules = ["/"]
+    template_name = "templates/pagureissues.html"
+    chrome = panel("Newest Open Tickets on Pagure")
+
+    def get_context(self, instance, *args, **kwargs):
+        get_issues = GetIssues(instance)
+        context = dict(repo=instance.config["repo"])
+        context.update(get_issues())
+        return context
+
+
+class GetIssues(CachedFunction):
+    ''' Data for pagure issues widget
+    Queries Pagure api for issues '''
+
+    def execute(self):
+        repo = self.instance.config["repo"]
+
+        url = '/'.join([pagure_url, repo, "issues"])
+        issue_response = requests.get(url)
+        data = issue_response.json()
+        total = data['total_issues']
+
+        all_issues = list()
+        for issue in data['issues']:
+
+            issue_assignee = None
+            if issue['assignee']:
+                issue_assignee = issue['assignee']['name']
+
+            issue_project_user = None
+            if 'project' in issue:
+                issue_project_name = issue['project']['name']
+                if issue['project']['parent']:
+                    issue_project_user = issue['project']['user']['username']
+                else:
+                    if '/' in repo:
+                        issue_project_name, issue_project_user = \
+                            repo.split('/', 1)
+                    else:
+                        issue_project_name = repo
+
+            all_issues.append(
+                dict(
+                    issue_project_name=issue_project_name,
+                    issue_project_user=issue_project_user,
+                    issue_id=issue['id'],
+                    issue_title=issue['title'][:45],
+                    issue_title_full=issue['title'],
+                    issue_openedby=issue['user']['name'],
+                    issue_assignee=issue_assignee,
+                )
+            )
+
+        all_issues.reverse()
+        return dict(
+            total=total,
+            all_issues=all_issues,
+        )
+
+    def should_invalidate(self, message):
+        raise NotImplementedError

